> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/sdn/location/describedatacenterswithservice.md).

# DescribeDatacentersWithService

## 1. API Description

This API (DescribeDatacentersWithService) is used to query Data Centers with Service

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type                                                           | Description             |
| -------------- | -------- | -------------------------------------------------------------- | ----------------------- |
| cloudRegionId  | No       | String                                                         | Public cloud region ID. |
| dcId           | No       | String                                                         | Data center ID.         |
| serviceType    | No       | [ServiceType](/api-reference/sdn/datastructure.md#servicetype) | Service type.           |

## 3. Output Parameters

| Parameter Name | Type                                                                                                        | Description                                                                                                           |
| -------------- | ----------------------------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String                                                                                                      | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| dcSet          | Array of [DataCenterWithServiceResponse](/api-reference/sdn/datastructure.md#datacenterwithserviceresponse) | Result set.                                                                                                           |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Filter by serviceType to get data center information that supports AWS Cloud.**

```
POST /api/v2/sdn HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: DescribeDatacentersWithService
<Common Request Params>

Request: 
{
    "serviceType": "AWS"
}

Response: 
{
    "requestId": "TEEFDCA5B-76FB-4E91-A18E-DF7F5D2CE41F",
    "response": {
        "requestId": "TEEFDCA5B-76FB-4E91-A18E-DF7F5D2CE41F",
        "dcSet": [{
            "dcId":"NYC1",
            "areaName": "North America",
            "dcName": "Digital Realty JFK12",
            "cityName": "New York City",
            "cloudRegionId": "ap-east-1",
            "latitude": 40.718651,
            "longitude": -74.008261,
            "dcAddress": "111 8th Ave, New York, NY 10011, USA",
            "countryName": "United States",
            "serviceTypes": ["AWS", "DATACENTER_PORT"]
        }]
    }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code | Description |
| ---------------- | ---------- | ----------- |
